
Ruby - Bug #20566

string << 0xC2 should raise a RangeError if the string encoding is Encoding::ASCII

06/09/2024 12:22 AM - postmodern (Hal Brodigan)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.4.0preview1 (2024-05-16 master

9d69619623) [x86_64-linux]

Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:

UNKNOWN

Description

I noticed that appending extended ASCII characters (0x80 - 0xff) works when the String's encoding is Encoding::ASCII, as well as

Encoding::ASCII_8BIT. I was under the impression that Encoding::ASCII only covers the regular ASCII character set (0x00 - 0x7F). I

believe appending 0xC2 to a String with Encoding::ASCII should raise a RangeError.

Steps To Reproduce

str = String.new(encoding: Encoding::ASCII)

str << 0xC2

 

Expected Result

RangeError: character 194 is out of range

 

Actual Result

"\xC2"

Related issues:

Related to Ruby - Bug #18973: Kernel#sprintf: %c allows codepoints above 127 ... Closed

Associated revisions

Revision dd8903fed72c2d06fe7a0ca6b5ef88e9140be451 - 06/09/2024 01:11 AM - nobu (Nobuyoshi Nakada)

[Bug #20566] Mention out-of-range argument cases in String#<<

Also [Bug #18973].

Revision dd8903fed72c2d06fe7a0ca6b5ef88e9140be451 - 06/09/2024 01:11 AM - nobu (Nobuyoshi Nakada)

[Bug #20566] Mention out-of-range argument cases in String#<<

Also [Bug #18973].

Revision dd8903fe - 06/09/2024 01:11 AM - nobu (Nobuyoshi Nakada)

[Bug #20566] Mention out-of-range argument cases in String#<<

Also [Bug #18973].

History

#1 - 06/09/2024 12:44 AM - nobu (Nobuyoshi Nakada)

- Related to Bug #18973: Kernel#sprintf: %c allows codepoints above 127 for 7-bits ASCII encoding added

#2 - 06/09/2024 12:45 AM - nobu (Nobuyoshi Nakada)

It is a spec.

#3 - 06/09/2024 09:45 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|dd8903fed72c2d06fe7a0ca6b5ef88e9140be451.
https://bugs.ruby-lang.org/issues/18973#note-6
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/dd8903fed72c2d06fe7a0ca6b5ef88e9140be451


[Bug #20566] Mention out-of-range argument cases in String#<<

Also [Bug #18973].
